    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------
    028     * DefaultValueDataset.java
    029     * ------------------------
    030     * (C) Copyright 2003-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id $
    036     *
    037     * Changes
    038     * -------
    039     * 27-Mar-2003 : Version 1 (DG);
    040     * 18-Aug-2003 : Implemented Cloneable (DG);
    041     * 03-Mar-2005 : Implemented PublicCloneable (DG);
    042     * ------------- JFREECHART 1.0.x ---------------------------------------------
    043     * 30-Jan-2007 : Added explicit super() call in constructor (for clarity) (DG);
    044     *
    045     */
    046
    047    package org.jfree.data.general;
    048
    049    import java.io.Serializable;
    050
    051    import org.jfree.util.ObjectUtilities;
    052    import org.jfree.util.PublicCloneable;
    053
    054    /**
    055     * A dataset that stores a single value (that is possibly <code>null</code>).
    056     * This class provides a default implementation of the {@link ValueDataset}
    057     * interface.
    058     */
    059    public class DefaultValueDataset extends AbstractDataset
    060                                     implements ValueDataset,
    061                                                Cloneable, PublicCloneable,
    062                                                Serializable {
    063
    064        /** For serialization. */
    065        private static final long serialVersionUID = 8137521217249294891L;
    066
    067        /** The value. */
    068        private Number value;
    069
    070        /**
    071         * Constructs a new dataset, initially empty.
    072         */
    073        public DefaultValueDataset() {
    074            this(null);
    075        }
    076
    077        /**
    078         * Creates a new dataset with the specified value.
    079         *
    080         * @param value  the value.
    081         */
    082        public DefaultValueDataset(double value) {
    083            this(new Double(value));
    084        }
    085
    086        /**
    087         * Creates a new dataset with the specified value.
    088         *
    089         * @param value  the initial value (<code>null</code> permitted).
    090         */
    091        public DefaultValueDataset(Number value) {
    092            super();
    093            this.value = value;
    094        }
    095
    096        /**
    097         * Returns the value.
    098         *
    099         * @return The value (possibly <code>null</code>).
    100         */
    101        public Number getValue() {
    102            return this.value;
    103        }
    104
    105        /**
    106         * Sets the value and sends a {@link DatasetChangeEvent} to all registered
    107         * listeners.
    108         *
    109         * @param value  the new value (<code>null</code> permitted).
    110         */
    111        public void setValue(Number value) {
    112            this.value = value;
    113            notifyListeners(new DatasetChangeEvent(this, this));
    114        }
    115
    116        /**
    117         * Tests this dataset for equality with an arbitrary object.
    118         *
    119         * @param obj  the object (<code>null</code> permitted).
    120         *
    121         * @return A boolean.
    122         */
    123        public boolean equals(Object obj) {
    124            if (obj == this) {
    125                return true;
    126            }
    127            if (obj instanceof ValueDataset) {
    128                ValueDataset vd = (ValueDataset) obj;
    129                return ObjectUtilities.equal(this.value, vd.getValue());
    130            }
    131            return false;
    132        }
    133
    134        /**
    135         * Returns a hash code.
    136         *
    137         * @return A hash code.
    138         */
    139        public int hashCode() {
    140            return (this.value != null ? this.value.hashCode() : 0);
    141        }
    142
    143    }